package soda;

import com.wazeegroup.physhun.engine.ProcessContainer;
import com.wazeegroup.physhun.framework.StateModel;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import soda.events.CoinReturnPressed;

/**
 *  2005 Wazee Group, LLC
 *
 * @author Justin McCarter
 *         Date: Nov 17, 2005
 *         Copyright 2005-2008 Wazee Group, LLC
 *         Licensed under the Apache License, Version 2.0 (the "License");
 *         you may not use this file except in compliance with the License.
 *         You may obtain a copy of the License at
 *         <p/>
 *         http://www.apache.org/licenses/LICENSE-2.0
 *         <p/>
 *         Unless required by applicable law or agreed to in writing, software
 *         distributed under the License is distributed on an "AS IS" BASIS,
 *         WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *         See the License for the specific language governing permissions and
 *         limitations under the License.
 */
public class RunExample {
    public static void main(String[] args) {
        SodaTransaction sodaTx = new SodaTransaction("mySodaTransaction");
        ClassPathXmlApplicationContext ctx = new ClassPathXmlApplicationContext(new String[]{"sodaModel.xml", "soda-processConfig.xml"});
        ProcessContainer container = (ProcessContainer)ctx.getBean("container", ProcessContainer.class);
        StateModel stateModel = (StateModel) ctx.getBean("stateModel");  //inflate and retrieve the stateModel bean.
        container.startProcess(sodaTx, stateModel);
        container.sendTriggerEventToProcess("mySodaTransaction", new soda.events.FundsAdded(0.1f)); // put in a dime
        container.sendTriggerEventToProcess("mySodaTransaction", new soda.events.SelectionButtonPressed("Coke")); //push the coke button
        container.sendTriggerEventToProcess("mySodaTransaction", new CoinReturnPressed());
    }
}
