package soda;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import java.util.ArrayList;

/**
 * Created by IntelliJ IDEA.
 * User: Justin McCarter
 * Date: Feb 24, 2006
 * Time: 12:05:44 PM
 * To change this template use File | Settings | File Templates.
 */
public class VirtualSodaSodaTransaction extends SodaTransaction {

    public VirtualSodaSodaTransaction(String id) {
        super(id);
    }

    public void setFunds(float funds) {
        float oldValue = getFunds();
        super.setFunds(funds);
        PropertyChangeEvent event = new PropertyChangeEvent(this, "funds", new Float(oldValue), new Float(funds));
        for (PropertyChangeListener listener:listenerList) {
            listener.propertyChange(event);
        }
    }

    public void setLastMessage(String lastMessage) {
        String oldValue = getLastMessage();
        super.setLastMessage(lastMessage);
        PropertyChangeEvent event = new PropertyChangeEvent(this, "lastMessage", oldValue, lastMessage);
        for (PropertyChangeListener listener:listenerList) {
            listener.propertyChange(event);
        }
    }

    //This is just something for the UI to hook into so that it can display state changes
    private ArrayList<PropertyChangeListener> listenerList = new ArrayList<PropertyChangeListener>();
    public void addChangeListener(PropertyChangeListener listener) {
        listenerList.add(listener);
    }
    public void removeChangeListener(PropertyChangeListener listener) {
        listenerList.remove(listener);
    }
}
